
package common;

import java.util.Observable;
import javax.swing.DefaultBoundedRangeModel;
/**
 *
 * @author B. Gaertner
 */
public class ObservableValueFromRangeModel extends Observable {
    /**
     * der aktuelle Wert des Schiebereglers
     */
    protected DefaultBoundedRangeModel valueSource;

    public ObservableValueFromRangeModel(DefaultBoundedRangeModel m) {
        super();
        valueSource = m;
    }

    /**
     * Observer rufen diese Methode auf, um den aktuellen Wert des
     * beobachteten Schiebereglers zu erfragen
     * @return den aktuellen wert des Schiebereglers, ein int.
     */
    public DefaultBoundedRangeModel getCurrentValue ()
    {
        return valueSource;
    }

    
    public void signalChange() {
        this.setChanged();
        this.notifyObservers();
    }
}
