package common;
import javax.swing.BoundedRangeModel;
import javax.swing.DefaultBoundedRangeModel;
import javax.swing.JSlider;

/**
 *
 * @author Projekte
 */
public class RemoveableJSlider  extends JSlider
{
    /**
     * Create a horizontal slider using the specified BoundedRangeModel
     * @param brm
     */
    public RemoveableJSlider(BoundedRangeModel brm) {
        super(brm);
    }

    /**
     * Creates a slider using the specified orientation with the range 0 to 100
     * and an initial value of 50.
     * @param orientation the orientation of the slider - either
     * SwingConstants.VERTICAL or SwingConstants.HORIZONTAL
     */
    public RemoveableJSlider(int orientation)  {
        super(orientation);
    }

    /**
     * Creates a horizontal slider using the specified boundary values
     * min and max. The initial value of the slider is the average of the
     * boundary values.
     * @param min the minimum value of the slider
     * @param max the maximum value of the slider
     */
    public RemoveableJSlider(int min, int max) {
        super(min, max);
    }

    /**
     * Creates a horizontal slider using the specified boundary values
     * min and max and initial value.
     * @param min the minimum value of the slider
     * @param max the maximum value of the slider
     * @param value the initial value of the slider
     */
    public RemoveableJSlider(int min, int max, int value) {
        super(min, max, value);
    }

    /**
     * Create a slider with the specified orientation, boundary values
     * and initial value.
     * @param orientation the orientation of the slider - either
     * SwingConstants.VERTICAL or SwingConstants.HORIZONTAL
     * @param min the minimum value of the slider
     * @param max the maximum value of the slider
     * @param value the initial value of the slider
     */
    public RemoveableJSlider(int orientation, int min, int max, int value) {
        super(orientation, min, max, value);
    }

    /**
     *
     */
    @Override
    public void removeNotify() {
        super.removeNotify();
        this.setModel(new DefaultBoundedRangeModel());
        // The installation of a new model disconnects the old model
        //  from this slider. I found no other way to accomplish this.
    }
}
