
package common;

import javax.swing.DefaultBoundedRangeModel;

/**
 * Das ist ein Adapter, derRohdaten eines DefaultBoundedRangeModel in
 * Problemdaten umwandelt, die von Instrumenten angezeigt werden können,
 * die selbst keine Umwandlung von Rohdaten vornehmen.
 *
 * Dieser Adapter vermittelt nur eine Skalierung; eine Verschiebung des
 * Nullpunktes findet hier nicht statt.
 * @author Projekte
 */
public class ValueTransformation {

    private int factor = 1;
    private double resolution = 1.0;
    private DefaultBoundedRangeModel valueSource;

    public ValueTransformation (DefaultBoundedRangeModel vs, int res) {
        valueSource = vs;
        factor = res;
        resolution = res;
    }

    public double getValue() {
        return valueSource.getValue()/resolution;
    }

    public void setValue(double v) {
        valueSource.setValue(scaleForRangeModel(v));
    }


    private int scaleForRangeModel(double v) {
        float fl = (float) v;
        return Math.round(fl*factor);
    }
}
