
package drawables;

import java.awt.Graphics2D;
import java.awt.Rectangle;

import java.util.ListIterator;
import javax.swing.DefaultBoundedRangeModel;

/**
 *
 * @author Projekte
 */
public abstract class AbstractLayer {


    /**
     * Do nothing for a non-caching layer. Caching layers override
     * this method to clear the cache.
     */
    public void invalidateCache() {

    }

    public boolean hasValidCachedImage() {
        return false;
    }

    public boolean valueChanged(DefaultBoundedRangeModel m, boolean change) {
        return change;
    }

    /**
     *
     * @param paintTool
     * @param copyTool
     * @param lowerLayers
     * @param area
     * @param rf
     */
    protected void renderWith(Graphics2D paintTool,
            Graphics2D copyTool,
            ListIterator<AbstractLayer> lowerLayers,
            Rectangle area,
            ReferenceFrame rf) {
        if (lowerLayers.hasPrevious()) {
            AbstractLayer p = lowerLayers.previous();
            p.renderWith(paintTool, copyTool, lowerLayers, area, rf);
        }
    }
}
