
package drawables;

import java.awt.geom.Point2D;


/**
 * Eine Instanz beschreibt die visuelle Darstellung eines Wertebereichs
 * auf einem Kreisbogen.
 * @author development
 */
public class AngularRange {
    /**
     * The start angle of an angular range,
     * measured clockwise from the positive x-axis (3 o'clock mark).
     * Note that this is not the measuring method that is used to
     * paint Java arcs. It is the measuring method that is used to
     * specify arcs in C#.
     */
    double startAngle;

    /**
     *
     */
    double swapAngle;
    Point2D center;

    public AngularRange(Point2D cp, double start, double swap) {
        center = cp;
        startAngle = start;
        swapAngle = swap;
    }

    public double endAngle() {
        return (startAngle + swapAngle);
    }
}
