
package drawables;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.util.ListIterator;

/**
 *
 * @author Projekte
 */
public class BackgroundLayer extends AbstractLayer {

    Color backgroundColor;
    ReferenceFrame referenceFrame;

    public BackgroundLayer (Color bc, ReferenceFrame rc) {
        backgroundColor = bc;
        referenceFrame = rc;
    }

    @Override protected void renderWith (Graphics2D paintTool,
            Graphics2D copyTool,
            ListIterator<AbstractLayer> iterator,
            Rectangle area,
            ReferenceFrame rf) {
        super.renderWith(paintTool, copyTool, iterator, area, rf);
        paintTool.setColor(backgroundColor);
        paintTool.fillRect(referenceFrame.xMin, referenceFrame.yMin,
                referenceFrame.width(), referenceFrame.height());
    }

}
