
package drawables;

import java.awt.BasicStroke;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.geom.Arc2D;
import java.util.ListIterator;

/**
 *
 * @author development
 */
public class CircularArcLayer extends AbstractEllipticalVisualElement {

        public CircularArcLayer
            (AngularRange ar,
             double r, VisualProperties vp) {
        super(ar, r, vp);
    }

    @Override protected void renderWith (Graphics2D paintTool,
            Graphics2D copyTool,
            ListIterator<AbstractLayer> iterator,
            Rectangle area,
            ReferenceFrame rf) {
        super.renderWith(paintTool, copyTool, iterator, area, rf);

        paintTool.setColor(visualProperties.lineColor);
        paintTool.setStroke( new BasicStroke(visualProperties.lineWidth,
                BasicStroke.CAP_SQUARE,
                BasicStroke.JOIN_ROUND));

        Arc2D.Double arc =
                new Arc2D.Double(-radius, -radius, 2*radius, 2*radius,
                  - angularRange.startAngle, - angularRange.swapAngle, Arc2D.OPEN);

        paintTool.draw(arc);
        /*
        long rl = Math.round(radius);
        int r = (int) rl;
        paintTool.drawArc(-r, -r, 2*r, 2*r,
                -(int)Math.round(angularRange.startAngle),
                -(int)Math.round(angularRange.swapAngle));
        */
    }
}
