
package drawables;

import java.awt.Graphics2D;
import java.awt.geom.Path2D;

/**
 *
 * @author Projekte
 */
public class DoublePointedNeedle extends AbstractNeedleShape {

    protected double upperLength, upperWidth;
    protected double centerWidth;
    protected double bottomLength, bottomWidth;
    protected int topCap;
    protected int bottomCap;

    public DoublePointedNeedle(double tl, double tw,
            double cw,
            double bl, double bw,
            int tc, int bc) {
        upperLength = tl;
        upperWidth = tw;
        centerWidth = cw;
        bottomLength = bl;
        bottomWidth = bw;
        topCap = tc;
        bottomCap = bc;
    }

    @Override
    public void renderWith(Graphics2D paintTool) {
        Path2D.Double path = new Path2D.Double();
        path.moveTo(upperLength, -upperWidth/2.0);
        path.lineTo(0.0, - centerWidth/2.0);
        path.lineTo(-bottomLength, -bottomWidth/2.0);
        path.lineTo(-bottomLength, bottomWidth/2.0);
        path.lineTo(0.0, centerWidth/2.0);
        path.lineTo(upperLength, upperWidth/2.0);
        path.closePath();
        paintTool.fill(path);
    }
}
