
package drawables;

import java.awt.Graphics2D;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Rectangle;

import java.awt.geom.Point2D;
import java.util.ListIterator;

/**
 *
 * @author Projekte
 */
public class GaugeLabel extends AbstractLayer {

    private VisualStringProperties stringProperties;
    private Point2D placement;
    String text;

    public GaugeLabel(VisualStringProperties vsp,
            Point2D pl, String str) {
        stringProperties = vsp;
        placement = pl;
        text = str;
    }

    @Override protected void renderWith (Graphics2D paintTool,
            Graphics2D copyTool,
            ListIterator<AbstractLayer> iterator,
            Rectangle area,
            ReferenceFrame rf) {
        super.renderWith(paintTool, copyTool, iterator, area, rf);
        Font schrift = stringProperties.font;
        FontMetrics metrics = paintTool.getFontMetrics(schrift);

        int breite = metrics.stringWidth(text);
        float yHeight = metrics.getMaxAscent() - metrics.getMaxDescent();
        //int xPos = bereich.width / 2 - breite / 2;
        //int yPos = bereich.height / 2 + metrics.getDescent();

        paintTool.setFont(schrift);
        paintTool.setColor(stringProperties.textColor);
        paintTool.drawString(text,
                (float)placement.getX() - breite/2.0f,
                (float)placement.getY() + yHeight/2.0f);
        paintTool.setFont(null);
    }
}
