
package drawables;

import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.geom.AffineTransform;
import java.util.ListIterator;
import javax.swing.DefaultBoundedRangeModel;
/**
 *
 * @author Projekte
 */
public class NeedleLayer extends AbstractIndicatorLayer {

    protected Needle needle;

    public NeedleLayer (Needle n, DefaultBoundedRangeModel vs) {
        super(vs);
        needle = n;
    }

    @Override
    protected void renderWith (Graphics2D paintTool,
            Graphics2D copyTool,
            ListIterator<AbstractLayer> iterator,
            Rectangle area,
            ReferenceFrame rf) {
        super.renderWith(paintTool, copyTool, iterator, area, rf);
        double startAngle, endAngle, currentAngle;
        double minValue, maxValue, currentValue;
        startAngle = needle.angularRange.startAngle;
        endAngle = needle.angularRange.endAngle();
        minValue = valueSource.getMinimum();
        maxValue = valueSource.getMaximum();
        currentValue = valueSource.getValue();
        currentAngle =
                needle.scaleProperties.isReverse()
                ? (endAngle - startAngle)*(currentValue - minValue)/(minValue - maxValue) + endAngle
                : (endAngle - startAngle)*(currentValue - minValue)/(maxValue - minValue) + startAngle;
        AffineTransform transformation = paintTool.getTransform();
        //  translate and rotate the coordinate system before the needle is drawn:
        paintTool.translate(needle.angularRange.center.getX(),
                needle.angularRange.center.getY());
        //  rotation here
        paintTool.rotate(Math.toRadians(currentAngle));
        needle.renderWith(paintTool);
        paintTool.setTransform(transformation);
    }
}
