
package drawables;

import java.awt.Color;
import java.awt.Graphics2D;

/**
 *
 * @author Projekte
 */
public class NeedleOnStraightScale extends AbstractValuePresenter {

    StraightRange range;
    double coordinateOfMoveLine;

    public NeedleOnStraightScale (StraightRange r,
            ScaleProperties sp,
            Color col,
            double ml,
            AbstractNeedleShape ns) {
        super(sp, ns, col);
        range = r;
        coordinateOfMoveLine = ml;
    }

    @Override
    public void renderWith(Graphics2D paintTool) {
        if (range.isHorizontal()) {
            paintTool.translate(0.0, coordinateOfMoveLine);
            paintTool.rotate(Math.toRadians(90.0));
            super.renderWith(paintTool);
        } else {
            paintTool.translate(coordinateOfMoveLine, 0.0);
            //paintTool.rotate(Math.toRadians(90.0));
            super.renderWith(paintTool);
        }
    }
}
