
package drawables;

/**
 * The reference frame introduces the coordinate system for all layers
 * that comprise an instrument.
 * Together with the Size of the instrument presenter, the reference
 * frame is used to compute an affine transformation that is used to
 * draw the instrument with the aspect ratio of the reference frame.
 * @author Projekte
 */
public class ReferenceFrame {
    int xMin, xMax;
    int yMin, yMax;

    public ReferenceFrame(int x0, int x1, int y0, int y1) {
        xMin = x0;
        xMax = x1;
        yMin = y0;
        yMax = y1;
    }

    public double aspectRatio() {
        return (xMax - xMin)/(float)(yMax - yMin);
    }

    public int height() {
        return yMax - yMin;
    }

    public int width() {
        return xMax - xMin;
    }


    public double xOrigin() {
        return -xMin/(float)(xMax - xMin);
    }

    public double yOrigin() {
        return -yMin/(float)(yMax - yMin);
    }
}

