
package drawables;

import java.awt.Graphics2D;
import java.awt.geom.Path2D;

/**
 *
 * @author Projekte
 */
public class SimpleNeedle extends AbstractNeedleShape {

    protected double topLength, topWidth;
    protected double bottomLength, bottomWidth;
    protected int topCap;
    protected int bottomCap;

    public SimpleNeedle(double tl, double tw,
            double bl, double bw,
            int tc, int bc) {
        topLength = tl;
        topWidth = tw;
        bottomLength = bl;
        bottomWidth = bw;
        topCap = tc;
        bottomCap = bc;
    }

    @Override
    public void renderWith(Graphics2D paintTool) {
        Path2D.Double path = new Path2D.Double();
        path.moveTo(topLength, -topWidth/2.0);
        path.lineTo(-bottomLength, -bottomWidth/2.0);
        path.lineTo(-bottomLength, bottomWidth/2.0);
        path.lineTo(topLength, topWidth/2.0);
        path.closePath();
        paintTool.fill(path);
    }
}
