
package drawables;

import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.util.ListIterator;
import javax.swing.DefaultBoundedRangeModel;

/**
 *
 * @author Projekte
 */
public class StraightNeedleLayer extends AbstractIndicatorLayer {
    NeedleOnStraightScale needle;

    public StraightNeedleLayer(NeedleOnStraightScale n,
            DefaultBoundedRangeModel vs) {
        super(vs);
        needle = n;
    }

    /**
     * This method is certainly not optimal. One should split it into two
     * different methods - one for horizontal scales and one for vertical scales.
     * @param paintTool
     * @param copyTool
     * @param iterator
     * @param area
     * @param rf
     */
    @Override
    protected void renderWith (Graphics2D paintTool,
            Graphics2D copyTool,
            ListIterator<AbstractLayer> iterator,
            Rectangle area,
            ReferenceFrame rf) {
        super.renderWith(paintTool, copyTool, iterator, area, rf);

        AffineTransform transformation = paintTool.getTransform();

        Point2D startPnt = needle.range.startPoint;
        double startPos = needle.range.isHorizontal()
                           ? startPnt.getX()
                           : startPnt.getY();
        double endPos = startPos + needle.range.length;
        double minValue = valueSource.getMinimum();
        double maxValue = valueSource.getMaximum();
        double currentValue = valueSource.getValue();
        double currentPos =
                (needle.range.isHorizontal() ? needle.scaleProperties.isReverse()
                                             : ! needle.scaleProperties.isReverse())
                  ? (endPos - startPos)*(currentValue - minValue)/(minValue - maxValue) + endPos
                  : (endPos - startPos)*(currentValue - minValue)/(maxValue - minValue) + startPos;
        if (needle.range.isHorizontal()) {
            paintTool.translate(currentPos, 0.0);
        } else {
            paintTool.translate(0.0, currentPos);
        }
        needle.renderWith(paintTool);
        paintTool.setTransform(transformation);
    }
}
