
package drawables;
import java.util.Enumeration;
/**
 *
 * @author Projekte
 */
public class TickSequence implements Enumeration<Integer>
{
    private ScaleProperties scaleProperties;
    private TickSequenceRule rule;

    private int lastValue;
    private int currentValue;
    private int offset;
    private boolean hasNextElement;

    public TickSequence (ScaleProperties sp, TickSequenceRule tsr) {
        scaleProperties = sp;
        rule = tsr;
        lastValue = scaleProperties.numberOfSections;
        currentValue = rule.firstVisibleTick;
        offset = currentValue;
        hasNextElement = currentValue <=lastValue;
    }

    @Override
    public boolean hasMoreElements() {
        return hasNextElement;
    }

    @Override
    public Integer nextElement() {
        int valueToReturn = currentValue;
        currentValue += rule.increment;
        offset += rule.increment;
        if (offset == rule.skip) {
            currentValue += rule.increment;
            offset = rule.increment;
        }
        hasNextElement = currentValue <= lastValue;
        return valueToReturn;
    }


}
