package window;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager;
import mvc.ComponentContainer;

/**
 *
 * @author development
 */
public class SimpleInstrument extends InstrumentExplorer
                              implements LayoutManager {

    SimpleInstrumentModel model;

    public SimpleInstrument (SimpleInstrumentModel sm) {
        model = sm;
    }

    @Override
    public void installInto(ComponentContainer<InstrumentExplorerModel> cc) {
        cc.setLayout(this);
        InstrumentPaintArea paintArea = new InstrumentPaintArea(model.getValueListeners(), model);
        cc.add(paintArea);
    }

    @Override
    public void addLayoutComponent(String name, Component comp) {
        //  no action needed
    }

    @Override
    public void removeLayoutComponent(Component comp) {
        //  no action needed
    }

    @Override
    public Dimension preferredLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 100 + insets.left + insets.right;
        dim.height = 100 + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public Dimension minimumLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 60 + insets.left + insets.right;
        dim.height = 26 + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public void layoutContainer(Container parent) {

        Insets insets = parent.getInsets();
        final int maxWidth = parent.getWidth()
                       - (insets.left + insets.right) - 1;
        final int maxHeight = parent.getHeight()
                        - (insets.top + insets.bottom);
        final int nComps = parent.getComponentCount();
        final int y = insets.top;
        if (nComps == 0) {
            return;
        }

        Component c = parent.getComponent(0);            // paint region
        c.setBounds(insets.left, y, maxWidth, maxHeight);
    }

}
