package window;

import common.SliderListener;
import common.RemoveableJSlider;
//import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager;
import javax.swing.JSlider;
import mvc.ComponentContainer;

/**
 *
 * @author development
 */
public class TestableInstrument extends InstrumentExplorer
                                implements LayoutManager {

    TestableInstrumentModel model;

    public TestableInstrument (TestableInstrumentModel m) {
        model = m;
    }

    @Override
    public void installInto(ComponentContainer<InstrumentExplorerModel> cc) {
        cc.setLayout(this);
        RemoveableJSlider slider = new RemoveableJSlider(model.getSliderModel());
        slider.setOrientation(JSlider.VERTICAL);
        SliderListener sl = new SliderListener(model.getSliderModel());
        SliderListener[] listeners = new SliderListener[1];
        listeners[0] = sl;
        InstrumentPaintArea paintArea = new InstrumentPaintArea(listeners, model);
        //paintArea.setBackground(Color.WHITE);
        slider.addChangeListener(sl);
        cc.add(slider);
        cc.add(paintArea);
    }

    @Override
    public void addLayoutComponent(String name, Component comp) {
        //  no action needed
    }

    @Override
    public void removeLayoutComponent(Component comp) {
        //  no action needed
    }

    @Override
    public Dimension preferredLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 100
                    + insets.left + insets.right;
        dim.height = 100
                     + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public Dimension minimumLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 60
                    + insets.left + insets.right;
        dim.height = 26
                     + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public void layoutContainer(Container parent) {

        Insets insets = parent.getInsets();
        final int maxWidth = parent.getWidth()
                       - (insets.left + insets.right) - 1;
        final int maxHeight = parent.getHeight()
                        - (insets.top + insets.bottom);
        final int nComps = parent.getComponentCount();
        final int y = insets.top;
        final int sliderWidth = 60;
        if (nComps == 0) {
            return;
        }

        Component c = parent.getComponent(0);  // Slider
        c.setBounds(insets.left, y, sliderWidth, maxHeight);
        c = parent.getComponent(1);            // paint region
        c.setBounds(insets.left + sliderWidth, y, maxWidth - sliderWidth, maxHeight);
    }
}
