package window;

import common.SliderListener;
import common.RemoveableJSlider;
//import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager;
import javax.swing.JSlider;
import mvc.ComponentContainer;
/**
 *
 * @author development
 */
public class TestableMultiInstrument extends InstrumentExplorer
                                implements LayoutManager {
    TestableMultiInstrumentModel model;

    public TestableMultiInstrument (TestableMultiInstrumentModel m) {
        model = m;
    }

    @Override
    public void installInto(ComponentContainer<InstrumentExplorerModel> cc) {
        cc.setLayout(this);
        SliderListener[] listeners = new SliderListener[model.getNumberOfParameters()];
        for (int i = 0; i < model.getNumberOfParameters(); i++) {
            RemoveableJSlider slider = new RemoveableJSlider(model.getSliderModel(i));
            slider.setOrientation(JSlider.VERTICAL);
            SliderListener sl = new SliderListener(model.getSliderModel(i));
            slider.addChangeListener(sl);
            listeners [i] = sl;
            cc.add(slider);
        }

        InstrumentPaintArea paintArea = new InstrumentPaintArea(listeners, model);
        cc.add(paintArea);
    }

    @Override
    public void addLayoutComponent(String name, Component comp) {
        //  no action needed
    }

    @Override
    public void removeLayoutComponent(Component comp) {
        //  no action needed
    }

    @Override
    public Dimension preferredLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 100
                    + insets.left + insets.right;
        dim.height = 100
                     + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public Dimension minimumLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        //Always add the container's insets!
        Insets insets = parent.getInsets();
        dim.width = 60
                    + insets.left + insets.right;
        dim.height = 26
                     + insets.top + insets.bottom;

        return dim;
    }

    @Override
    public void layoutContainer(Container parent) {

        Insets insets = parent.getInsets();
        final int maxWidth = parent.getWidth()
                       - (insets.left + insets.right) - 1;
        final int maxHeight = parent.getHeight()
                        - (insets.top + insets.bottom);
        final int nComps = parent.getComponentCount();
        final int y = insets.top;
        final int sliderWidth = 60;
        if (nComps == 0) {
            return;
        }

        Component c;
        int x = 0;
        for (int i = 0; i < model.getNumberOfParameters();i++) {
            c = parent.getComponent(i);  // Slider
            c.setBounds(insets.left + x, y, sliderWidth, maxHeight);
            x += sliderWidth;
        }

        c = parent.getComponent(model.getNumberOfParameters());            // paint region
        c.setBounds(insets.left + x, y, maxWidth - x, maxHeight);
    }

}
